Loading...
Searching...
No Matches
icu::DateFormat Class Referenceabstract

DateFormat is an abstract class for a family of classes that convert dates and times from their internal representations to textual form and back again in a language-independent manner. More...

`#include <datefmt.h>`

Inheritance diagram for icu::DateFormat:

## Public Types

enum

EStyle {
kNone = -1 , kFull = 0 , kLong = 1 , kMedium = 2 ,
kShort = 3 , kDateOffset = kShort + 1 , kDateTime = 8 , kDateTimeOffset = kDateTime + 1 ,
kRelative = (1 << 7) , kFullRelative = (kFull | kRelative) , kLongRelative = kLong | kRelative , kMediumRelative = kMedium | kRelative ,
kShortRelative = kShort | kRelative , kDefault = kMedium , FULL = kFull , LONG = kLong ,
MEDIUM = kMedium , SHORT = kShort , DEFAULT = kDefault , DATE_OFFSET = kDateOffset ,
NONE = kNone , DATE_TIME = kDateTime
}

| Constants for various style patterns. More...

enum

EField {
kEraField = UDAT_ERA_FIELD , kYearField = UDAT_YEAR_FIELD , kMonthField = UDAT_MONTH_FIELD , kDateField = UDAT_DATE_FIELD ,
kHourOfDay1Field = UDAT_HOUR_OF_DAY1_FIELD , kHourOfDay0Field = UDAT_HOUR_OF_DAY0_FIELD , kMinuteField = UDAT_MINUTE_FIELD , kSecondField = UDAT_SECOND_FIELD ,
kMillisecondField = UDAT_FRACTIONAL_SECOND_FIELD , kDayOfWeekField = UDAT_DAY_OF_WEEK_FIELD , kDayOfYearField = UDAT_DAY_OF_YEAR_FIELD , kDayOfWeekInMonthField = UDAT_DAY_OF_WEEK_IN_MONTH_FIELD ,
kWeekOfYearField = UDAT_WEEK_OF_YEAR_FIELD , kWeekOfMonthField = UDAT_WEEK_OF_MONTH_FIELD , kAmPmField = UDAT_AM_PM_FIELD , kHour1Field = UDAT_HOUR1_FIELD ,
kHour0Field = UDAT_HOUR0_FIELD , kTimezoneField = UDAT_TIMEZONE_FIELD , kYearWOYField = UDAT_YEAR_WOY_FIELD , kDOWLocalField = UDAT_DOW_LOCAL_FIELD ,
kExtendedYearField = UDAT_EXTENDED_YEAR_FIELD , kJulianDayField = UDAT_JULIAN_DAY_FIELD , kMillisecondsInDayField = UDAT_MILLISECONDS_IN_DAY_FIELD , ERA_FIELD = UDAT_ERA_FIELD ,
YEAR_FIELD = UDAT_YEAR_FIELD , MONTH_FIELD = UDAT_MONTH_FIELD , DATE_FIELD = UDAT_DATE_FIELD , HOUR_OF_DAY1_FIELD = UDAT_HOUR_OF_DAY1_FIELD ,
HOUR_OF_DAY0_FIELD = UDAT_HOUR_OF_DAY0_FIELD , MINUTE_FIELD = UDAT_MINUTE_FIELD , SECOND_FIELD = UDAT_SECOND_FIELD , MILLISECOND_FIELD = UDAT_FRACTIONAL_SECOND_FIELD ,
DAY_OF_WEEK_FIELD = UDAT_DAY_OF_WEEK_FIELD , DAY_OF_YEAR_FIELD = UDAT_DAY_OF_YEAR_FIELD , DAY_OF_WEEK_IN_MONTH_FIELD = UDAT_DAY_OF_WEEK_IN_MONTH_FIELD , WEEK_OF_YEAR_FIELD = UDAT_WEEK_OF_YEAR_FIELD ,
WEEK_OF_MONTH_FIELD = UDAT_WEEK_OF_MONTH_FIELD , AM_PM_FIELD = UDAT_AM_PM_FIELD , HOUR1_FIELD = UDAT_HOUR1_FIELD , HOUR0_FIELD = UDAT_HOUR0_FIELD ,
TIMEZONE_FIELD = UDAT_TIMEZONE_FIELD
}

| Field selector for FieldPosition for DateFormat fields. More...

## Public Member Functions

virtual U_I18N_API | ~DateFormat ()
| Destructor.
virtual U_I18N_API DateFormat * | clone () const override=0
| Clones this object polymorphically.
virtual U_I18N_API bool | operator== (const Format &) const override
| Equality operator.
virtual U_I18N_API UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPosition &pos, UErrorCode &status) const override
| Format an object to produce a string.
virtual U_I18N_API UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPositionIterator *posIter, UErrorCode &status) const override
| Format an object to produce a string.
virtual U_I18N_API UnicodeString & | format (Calendar &cal, UnicodeString &appendTo, FieldPosition &fieldPosition) const =0
| Formats a date into a date/time string.
virtual U_I18N_API UnicodeString & | format (Calendar &cal, UnicodeString &appendTo, FieldPositionIterator *posIter, UErrorCode &status) const
| Formats a date into a date/time string.
U_I18N_API UnicodeString & | format (UDate date, UnicodeString &appendTo, FieldPosition &fieldPosition) const
| Formats a UDate into a date/time string.
U_I18N_API UnicodeString & | format (UDate date, UnicodeString &appendTo, FieldPositionIterator *posIter, UErrorCode &status) const
| Formats a UDate into a date/time string.
U_I18N_API UnicodeString & | format (UDate date, UnicodeString &appendTo) const
| Formats a UDate into a date/time string.
virtual U_I18N_API UDate | parse (const UnicodeString &text, UErrorCode &status) const
| Parse a date/time string.
virtual U_I18N_API void | parse (const UnicodeString &text, Calendar &cal, ParsePosition &pos) const =0
| Parse a date/time string beginning at the given parse position.
U_I18N_API UDate | parse (const UnicodeString &text, ParsePosition &pos) const
| Parse a date/time string beginning at the given parse position.
virtual U_I18N_API void | parseObject (const UnicodeString &source, Formattable &result, ParsePosition &parse_pos) const override
| Parse a string to produce an object.
virtual U_I18N_API UBool | isLenient () const
| Returns whether both date/time parsing in the encapsulated Calendar object and DateFormat whitespace & numeric processing is lenient.
virtual U_I18N_API void | setLenient (UBool lenient)
| Specifies whether date/time parsing is to be lenient.
virtual U_I18N_API UBool | isCalendarLenient () const
| Returns whether date/time parsing in the encapsulated Calendar object processing is lenient.
virtual U_I18N_API void | setCalendarLenient (UBool lenient)
| Specifies whether encapsulated Calendar date/time parsing is to be lenient.
virtual U_I18N_API const Calendar * | getCalendar () const
| Gets the calendar associated with this date/time formatter.
virtual U_I18N_API void | adoptCalendar (Calendar *calendarToAdopt)
| Set the calendar to be used by this date format.
virtual U_I18N_API void | setCalendar (const Calendar &newCalendar)
| Set the calendar to be used by this date format.
virtual U_I18N_API const NumberFormat * | getNumberFormat () const
| Gets the number formatter which this date/time formatter uses to format and parse the numeric portions of the pattern.
virtual U_I18N_API void | adoptNumberFormat (NumberFormat *formatToAdopt)
| Allows you to set the number formatter.
virtual U_I18N_API void | setNumberFormat (const NumberFormat &newNumberFormat)
| Allows you to set the number formatter.
virtual U_I18N_API const TimeZone & | getTimeZone () const
| Returns a reference to the TimeZone used by this DateFormat's calendar.
virtual U_I18N_API void | adoptTimeZone (TimeZone *zoneToAdopt)
| Sets the time zone for the calendar of this DateFormat object.
virtual U_I18N_API void | setTimeZone (const TimeZone &zone)
| Sets the time zone for the calendar of this DateFormat object.
virtual U_I18N_API void | setContext (UDisplayContext value, UErrorCode &status)
| Set a particular UDisplayContext value in the formatter, such as UDISPCTX_CAPITALIZATION_FOR_STANDALONE.
virtual U_I18N_API UDisplayContext | getContext (UDisplayContextType type, UErrorCode &status) const
| Get the formatter's UDisplayContext value for the specified UDisplayContextType, such as UDISPCTX_TYPE_CAPITALIZATION.
virtual U_I18N_API DateFormat & | setBooleanAttribute (UDateFormatBooleanAttribute attr, UBool newvalue, UErrorCode &status)
| Sets an boolean attribute on this DateFormat.
virtual U_I18N_API UBool | getBooleanAttribute (UDateFormatBooleanAttribute attr, UErrorCode &status) const
| Returns a boolean from this DateFormat May return U_UNSUPPORTED_ERROR if this instance does not support the specified attribute.
U_I18N_API UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, UErrorCode &status) const
| Formats an object to produce a string.
Public Member Functions inherited from icu::Format
virtual U_I18N_API | ~Format ()
| Destructor.
U_I18N_API bool | operator!= (const Format &other) const
| Return true if the given Format objects are not semantically equal.
U_I18N_API UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, UErrorCode &status) const
| Formats an object to produce a string.
U_I18N_API void | parseObject (const UnicodeString &source, Formattable &result, UErrorCode &status) const
| Parses a string to produce an object.
U_I18N_API Locale | getLocale (ULocDataLocaleType type, UErrorCode &status) const
| Get the locale for this format object.
U_I18N_API const char * | getLocaleID (ULocDataLocaleType type, UErrorCode &status) const
| Get the locale for this format object.
Public Member Functions inherited from icu::UObject
virtual | ~UObject ()
| Destructor.
virtual UClassID | getDynamicClassID () const
| ICU4C "poor man's RTTI", returns a UClassID for the actual ICU class.

## Static Public Member Functions

static U_I18N_API DateFormat * | createInstance ()
| Create a default date/time formatter that uses the SHORT style for both the date and the time.
static U_I18N_API DateFormat * | createTimeInstance (EStyle style=kDefault, const Locale &aLocale=Locale::getDefault())
| Creates a time formatter with the given formatting style for the given locale.
static U_I18N_API DateFormat * | createDateInstance (EStyle style=kDefault, const Locale &aLocale=Locale::getDefault())
| Creates a date formatter with the given formatting style for the given const locale.
static U_I18N_API DateFormat * | createDateTimeInstance (EStyle dateStyle=kDefault, EStyle timeStyle=kDefault, const Locale &aLocale=Locale::getDefault())
| Creates a date/time formatter with the given formatting styles for the given locale.
static U_I18N_API UnicodeString | getBestPattern (const Locale &locale, const UnicodeString &skeleton, UErrorCode &status)
| Returns the best pattern given a skeleton and locale.
static U_I18N_API DateFormat * | createInstanceForSkeleton (const UnicodeString &skeleton, UErrorCode &status)
| Creates a date/time formatter for the given skeleton and default locale.
static U_I18N_API DateFormat * | createInstanceForSkeleton (const UnicodeString &skeleton, const Locale &locale, UErrorCode &status)
| Creates a date/time formatter for the given skeleton and locale.
static U_I18N_API DateFormat * | createInstanceForSkeleton (Calendar *calendarToAdopt, const UnicodeString &skeleton, const Locale &locale, UErrorCode &status)
| Creates a date/time formatter for the given skeleton and locale.
static U_I18N_API const Locale * | getAvailableLocales (int32_t &count)
| Gets the set of locales for which DateFormats are installed.

## Protected Member Functions

U_I18N_API | DateFormat ()
| Default constructor.
U_I18N_API | DateFormat (const DateFormat &)
| Copy constructor.
U_I18N_API DateFormat & | operator= (const DateFormat &)
| Default assignment operator.
Protected Member Functions inherited from icu::Format
U_I18N_API void | setLocaleIDs (const char *valid, const char *actual)
U_I18N_API | Format ()
| Default constructor for subclass use only.
U_I18N_API | Format (const Format &)
U_I18N_API Format & | operator= (const Format &)

## Protected Attributes

Calendar * | fCalendar
| The calendar that DateFormat uses to produce the time field values needed to implement date/time formatting.
NumberFormat * | fNumberFormat
| The number formatter that DateFormat uses to format numbers in dates and times.

## Friends

class | DateFmtKeyByStyle

## Additional Inherited Members

Static Protected Member Functions inherited from icu::Format
static U_I18N_API void | syntaxError (const UnicodeString &pattern, int32_t pos, UParseError &parseError)
| Simple function for initializing a UParseError from a UnicodeString.

## Detailed Description

DateFormat is an abstract class for a family of classes that convert dates and times from their internal representations to textual form and back again in a language-independent manner.

Converting from the internal representation (milliseconds since midnight, January 1, 1970) to text is known as "formatting," and converting from text to millis is known as "parsing." We currently define only one concrete subclass of DateFormat: SimpleDateFormat, which can handle pretty much all normal date formatting and parsing actions.

DateFormat helps you to format and parse dates for any locale. Your code can be completely independent of the locale conventions for months, days of the week, or even the calendar format: lunar vs. solar.

To format a date for the current Locale, use one of the static factory methods:

    DateFormat* dfmt = DateFormat::createDateInstance();
    UDate myDate = Calendar::getNow();
    UnicodeString myString;
    myString = dfmt->format( myDate, myString );
    icu::Calendar::getNowstatic U_I18N_API UDate getNow()Returns the current UTC (GMT) time measured in milliseconds since 0:00:00 on 1/1/70 (derived from the...
    icu::DateFormat::formatvirtual U_I18N_API UnicodeString & format(const Formattable &obj, UnicodeString &appendTo, FieldPosition &pos, UErrorCode &status) const overrideFormat an object to produce a string.
    icu::DateFormat::createDateInstancestatic U_I18N_API DateFormat * createDateInstance(EStyle style=kDefault, const Locale &aLocale=Locale::getDefault())Creates a date formatter with the given formatting style for the given const locale.
    icu::DateFormat::DateFormatU_I18N_API DateFormat()Default constructor.
    icu::UnicodeStringUnicodeString is a string class that stores Unicode characters directly and provides similar function...Definition unistr.h:303
    UDatedouble UDateDate and Time data type.Definition utypes.h:218

If you are formatting multiple numbers, it is more efficient to get the format and use it multiple times so that the system doesn't have to fetch the information about the local language and country conventions multiple times.

    DateFormat* df = DateFormat::createDateInstance();
    UnicodeString myString;
    UDate myDateArr[] = { 0.0, 100000000.0, 2000000000.0 }; // test values
    for (int32_t i = 0; i < 3; ++i) {
        myString.remove();
        cout << df->format( myDateArr[i], myString ) << endl;
    }
    icu::UnicodeString::removeUnicodeString & remove()Removes all characters from the UnicodeString object and clears the bogus flag.Definition unistr.h:5095

To get specific fields of a date, you can use UFieldPosition to get specific fields.

    DateFormat* dfmt = DateFormat::createDateInstance();
    FieldPosition pos(DateFormat::YEAR_FIELD);
    UnicodeString myString;
    myString = dfmt->format( myDate, myString );
    cout << myString << endl;
    cout << pos.getBeginIndex() << "," << pos. getEndIndex() << endl;
    icu::FieldPositionFieldPosition is a simple class used by Format and its subclasses to identify fields in formatted out...Definition fieldpos.h:110

To format a date for a different Locale, specify it in the call to createDateInstance().

    DateFormat* df =
        DateFormat::createDateInstance( DateFormat::SHORT, Locale::getFrance());
    icu::Locale::getFrancestatic U_COMMON_API const Locale & getFrance()Useful constant for this country/region.

You can use a DateFormat to parse also.

    UErrorCode status = U_ZERO_ERROR;
    UDate myDate = df->parse(myString, status);
    icu::DateFormat::parsevirtual U_I18N_API UDate parse(const UnicodeString &text, UErrorCode &status) constParse a date/time string.
    UErrorCodeUErrorCodeStandard ICU4C error code type, a substitute for exceptions.Definition utypes.h:509
    U_ZERO_ERROR@ U_ZERO_ERRORNo error, no warning.Definition utypes.h:544

Use createDateInstance() to produce the normal date format for that country. There are other static factory methods available. Use createTimeInstance() to produce the normal time format for that country. Use createDateTimeInstance() to produce a DateFormat that formats both date and time. You can pass in different options to these factory methods to control the length of the result; from SHORT to MEDIUM to LONG to FULL. The exact result depends on the locale, but generally:

- SHORT is completely numeric, such as 12/13/52 or 3:30pm
- MEDIUM is longer, such as Jan 12, 1952
- LONG is longer, such as January 12, 1952 or 3:30:32pm
- FULL is pretty completely specified, such as Tuesday, April 12, 1952 AD or 3:30:42pm PST.

You can also set the time zone on the format if you wish. If you want even more control over the format or parsing, (or want to give your users more control), you can try casting the DateFormat you get from the factory methods to a SimpleDateFormat. This will work for the majority of countries; just remember to check getDynamicClassID() before carrying out the cast.

You can also use forms of the parse and format methods with ParsePosition and FieldPosition to allow you to

- Progressively parse through pieces of a string.
- Align any particular field, or find out where it is for selection on the screen.

User subclasses are not supported. While clients may write subclasses, such code will not necessarily work and will not be guaranteed to work stably from release to release.

Definition at line 144 of file datefmt.h.

## Member Enumeration Documentation

## EField

enum icu::DateFormat::EField

Field selector for FieldPosition for DateFormat fields.

Obsolete
  ICU 3.4 use UDateFormatField instead, since this API will be removed in that release

Definition at line 891 of file datefmt.h.

## EStyle

enum icu::DateFormat::EStyle

Constants for various style patterns.

These reflect the order of items in the DateTimePatterns resource. There are 4 time patterns, 4 date patterns, the default date-time pattern, and 4 date-time patterns. Each block of 4 values in the resource occurs in the order full, long, medium, short.

Stable
  ICU 2.4

Enumerator
FULL | These constants are provided for backwards compatibility only. Please use the C++ style constants defined above.

Definition at line 154 of file datefmt.h.

## Constructor & Destructor Documentation

## ~DateFormat()

virtual U_I18N_API icu::DateFormat::~DateFormat | ( |  | ) |

virtual

Destructor.

Stable
  ICU 2.0

References U_I18N_API.

## DateFormat() [1/2]

U_I18N_API icu::DateFormat::DateFormat | ( |  | ) |

protected

Default constructor.

Creates a DateFormat with no Calendar or NumberFormat associated with it. This constructor depends on the subclasses to fill in the calendar and numberFormat fields.

Stable
  ICU 2.0

References U_I18N_API.

Referenced by clone(), createDateInstance(), createInstance(), createInstanceForSkeleton(), createInstanceForSkeleton(), createInstanceForSkeleton(), createTimeInstance(), DateFormat(), operator=(), and setBooleanAttribute().

## DateFormat() [2/2]

U_I18N_API icu::DateFormat::DateFormat | ( | const DateFormat & |  | ) |

protected

Copy constructor.

Stable
  ICU 2.0

References DateFormat(), and U_I18N_API.

## Member Function Documentation

## adoptCalendar()

virtual U_I18N_API void icu::DateFormat::adoptCalendar | ( | Calendar * | calendarToAdopt | ) |

virtual

Set the calendar to be used by this date format.

Initially, the default calendar for the specified or default locale is used. The caller should not delete the Calendar object after it is adopted by this call. Adopting a new calendar will change to the default symbols.

Parameters

  calendarToAdopt | Calendar object to be adopted.

Stable
  ICU 2.0

Reimplemented in icu::SimpleDateFormat.

References U_I18N_API.

## adoptNumberFormat()

virtual U_I18N_API void icu::DateFormat::adoptNumberFormat | ( | NumberFormat * | formatToAdopt | ) |

virtual

Allows you to set the number formatter.

The caller should not delete the NumberFormat object after it is adopted by this call.

Parameters

  formatToAdopt | NumberFormat object to be adopted.

Stable
  ICU 2.0

Reimplemented in icu::SimpleDateFormat.

References U_I18N_API.

## adoptTimeZone()

virtual U_I18N_API void icu::DateFormat::adoptTimeZone | ( | TimeZone * | zoneToAdopt | ) |

virtual

Sets the time zone for the calendar of this DateFormat object.

The caller no longer owns the TimeZone object and should not delete it after this call.

Parameters

  zoneToAdopt | the TimeZone to be adopted.

Stable
  ICU 2.0

References U_I18N_API.

## clone()

virtual U_I18N_API DateFormat * icu::DateFormat::clone | ( |  | ) | const

override pure virtual

Clones this object polymorphically.

The caller owns the result and should delete it when done.

Returns
  clone, or nullptr if an error occurred

Stable
  ICU 2.0

Implements icu::Format.

Implemented in icu::SimpleDateFormat.

References DateFormat(), and U_I18N_API.

## createDateInstance()

U_I18N_API DateFormat * icu::DateFormat::createDateInstance | ( | EStyle | style = kDefault,
|  | const Locale & | aLocale = Locale::getDefault() )

static

Creates a date formatter with the given formatting style for the given const locale.

Parameters

  style

  The given formatting style. For example, SHORT for "M/d/yy" in the US locale. As currently implemented, relative date formatting only affects a limited range of calendar days before or after the current date, based on the CLDR <field type="day">/<relative> data: For example, in English, "Yesterday", "Today", and "Tomorrow". Outside of this range, dates are formatted using the corresponding non-relative style.

  aLocale | The given locale.

Returns
  A date formatter which the caller owns.

Stable
  ICU 2.0

References DateFormat(), icu::Locale::getDefault(), and U_I18N_API.

## createDateTimeInstance()

U_I18N_API DateFormat * icu::DateFormat::createDateTimeInstance | ( | EStyle | dateStyle = kDefault,
|  | EStyle | timeStyle = kDefault,
|  | const Locale & | aLocale = Locale::getDefault() )

static

Creates a date/time formatter with the given formatting styles for the given locale.

Parameters

  dateStyle

  The given formatting style for the date portion of the result. For example, SHORT for "M/d/yy" in the US locale. As currently implemented, relative date formatting only affects a limited range of calendar days before or after the current date, based on the CLDR <field type="day">/<relative> data: For example, in English, "Yesterday", "Today", and "Tomorrow". Outside of this range, dates are formatted using the corresponding non-relative style.

  timeStyle | The given formatting style for the time portion of the result. For example, SHORT for "h:mm a" in the US locale. Relative time styles are not currently supported.
  aLocale | The given locale.

Returns
  A date/time formatter which the caller owns.

Stable
  ICU 2.0

References icu::Locale::getDefault().

## createInstance()

U_I18N_API DateFormat * icu::DateFormat::createInstance | ( |  | ) |

static

Create a default date/time formatter that uses the SHORT style for both the date and the time.

Returns
  A date/time formatter which the caller owns.

Stable
  ICU 2.0

References DateFormat(), and U_I18N_API.

## createInstanceForSkeleton() [1/3]

U_I18N_API DateFormat * icu::DateFormat::createInstanceForSkeleton | ( | Calendar * | calendarToAdopt,
|  | const UnicodeString & | skeleton,
|  | const Locale & | locale,
|  | UErrorCode & | status )

static

Creates a date/time formatter for the given skeleton and locale.

Parameters

  calendarToAdopt | the calendar returned DateFormat is to use.
  skeleton | The skeleton e.g "yMMMMd." Fields in the skeleton can be in any order, and this method uses the locale to map the skeleton to a pattern that includes locale specific separators with the fields in the appropriate order for that locale.
  locale | The given locale.
  status | Any error returned here.

Returns
  A date/time formatter which the caller owns.

Stable
  ICU 55

References DateFormat(), and U_I18N_API.

## createInstanceForSkeleton() [2/3]

U_I18N_API DateFormat * icu::DateFormat::createInstanceForSkeleton | ( | const UnicodeString & | skeleton,
|  | const Locale & | locale,
|  | UErrorCode & | status )

static

Creates a date/time formatter for the given skeleton and locale.

Parameters

  skeleton | The skeleton e.g "yMMMMd." Fields in the skeleton can be in any order, and this method uses the locale to map the skeleton to a pattern that includes locale specific separators with the fields in the appropriate order for that locale.
  locale | The given locale.
  status | Any error returned here.

Returns
  A date/time formatter which the caller owns.

Stable
  ICU 55

References DateFormat(), and U_I18N_API.

## createInstanceForSkeleton() [3/3]

U_I18N_API DateFormat * icu::DateFormat::createInstanceForSkeleton | ( | const UnicodeString & | skeleton,
|  | UErrorCode & | status )

static

Creates a date/time formatter for the given skeleton and default locale.

Parameters

  skeleton | The skeleton e.g "yMMMMd." Fields in the skeleton can be in any order, and this method uses the locale to map the skeleton to a pattern that includes locale specific separators with the fields in the appropriate order for that locale.
  status | Any error returned here.

Returns
  A date/time formatter which the caller owns.

Stable
  ICU 55

References DateFormat(), and U_I18N_API.

## createTimeInstance()

U_I18N_API DateFormat * icu::DateFormat::createTimeInstance | ( | EStyle | style = kDefault,
|  | const Locale & | aLocale = Locale::getDefault() )

static

Creates a time formatter with the given formatting style for the given locale.

Parameters

  style | The given formatting style. For example, SHORT for "h:mm a" in the US locale. Relative time styles are not currently supported.
  aLocale | The given locale.

Returns
  A time formatter which the caller owns.

Stable
  ICU 2.0

References DateFormat(), icu::Locale::getDefault(), and U_I18N_API.

## format() [1/8]

virtual U_I18N_API UnicodeString & icu::DateFormat::format | ( | Calendar & | cal,
|  | UnicodeString & | appendTo,
|  | FieldPosition & | fieldPosition ) const

pure virtual

Formats a date into a date/time string.

This is an abstract method which concrete subclasses must implement.

On input, the FieldPosition parameter may have its "field" member filled with an enum value specifying a field. On output, the FieldPosition will be filled in with the text offsets for that field.

For example, given a time text "1996.07.10 AD at 15:08:56 PDT", if the given fieldPosition.field is UDAT_YEAR_FIELD, the offsets fieldPosition.beginIndex and statfieldPositionus.getEndIndex will be set to 0 and 4, respectively.

Notice that if the same time field appears more than once in a pattern, the status will be set for the first occurrence of that time field. For instance, formatting a UDate to the time string "1 PM PDT (Pacific Daylight Time)" using the pattern "h a z (zzzz)" and the alignment field DateFormat::TIMEZONE_FIELD, the offsets fieldPosition.beginIndex and fieldPosition.getEndIndex will be set to 5 and 8, respectively, for the first occurrence of the timezone pattern character 'z'.

Parameters

  cal | Calendar set to the date and time to be formatted into a date/time string. When the calendar type is different from the internal calendar held by this DateFormat instance, the date and the time zone will be inherited from the input calendar, but other calendar field values will be calculated by the internal calendar.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  fieldPosition | On input: an alignment field, if desired (see examples above) On output: the offsets of the alignment field (see examples above)

Returns
  Reference to 'appendTo' parameter.

Stable
  ICU 2.1

Implemented in icu::SimpleDateFormat.

References U_I18N_API.

## format() [2/8]

virtual U_I18N_API UnicodeString & icu::DateFormat::format | ( | Calendar & | cal,
|  | UnicodeString & | appendTo,
|  | FieldPositionIterator * | posIter,
|  | UErrorCode & | status ) const

virtual

Formats a date into a date/time string.

Subclasses should implement this method.

Parameters

  cal | Calendar set to the date and time to be formatted into a date/time string. When the calendar type is different from the internal calendar held by this DateFormat instance, the date and the time zone will be inherited from the input calendar, but other calendar field values will be calculated by the internal calendar.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  posIter | On return, can be used to iterate over positions of fields generated by this format call. Field values are defined in UDateFormatField. Can be nullptr.
  status | error status.

Returns
  Reference to 'appendTo' parameter.

Stable
  ICU 4.4

Reimplemented in icu::SimpleDateFormat.

References U_I18N_API.

## format() [3/8]

virtual U_I18N_API UnicodeString & icu::DateFormat::format | ( | const Formattable & | obj,
|  | UnicodeString & | appendTo,
|  | FieldPosition & | pos,
|  | UErrorCode & | status ) const

override virtual

Format an object to produce a string.

This method handles Formattable objects with a UDate type. If a the Formattable object type is not a Date, then it returns a failing UErrorCode.

Parameters

  obj | The object to format. Must be a Date.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  pos | On input: an alignment field, if desired. On output: the offsets of the alignment field.
  status | Output param filled with success/failure status.

Returns
  Reference to 'appendTo' parameter.

Stable
  ICU 2.0

Implements icu::Format.

Reimplemented in icu::SimpleDateFormat.

References U_I18N_API.

Referenced by icu::SimpleDateFormat::operator==().

## format() [4/8]

virtual U_I18N_API UnicodeString & icu::DateFormat::format | ( | const Formattable & | obj,
|  | UnicodeString & | appendTo,
|  | FieldPositionIterator * | posIter,
|  | UErrorCode & | status ) const

override virtual

Format an object to produce a string.

This method handles Formattable objects with a UDate type. If a the Formattable object type is not a Date, then it returns a failing UErrorCode.

Parameters

  obj | The object to format. Must be a Date.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  posIter | On return, can be used to iterate over positions of fields generated by this format call. Field values are defined in UDateFormatField. Can be nullptr.
  status | Output param filled with success/failure status.

Returns
  Reference to 'appendTo' parameter.

Stable
  ICU 4.4

Reimplemented from icu::Format.

Reimplemented in icu::SimpleDateFormat.

References U_I18N_API.

## format() [5/8]

U_I18N_API UnicodeString & icu::Format::format | ( | const Formattable & | obj,
|  | UnicodeString & | appendTo,
|  | UErrorCode & | status ) const

Formats an object to produce a string.

Parameters

  obj | The object to format.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  status | Output parameter filled in with success or failure status.

Returns
  Reference to 'appendTo' parameter.

Stable
  ICU 2.0

## format() [6/8]

U_I18N_API UnicodeString & icu::DateFormat::format | ( | UDate | date,
|  | UnicodeString & | appendTo ) const

Formats a UDate into a date/time string.

If there is a problem, you won't know, using this method. Use the overloaded format() method which takes a FieldPosition& to detect formatting problems.

Parameters

  date | The UDate value to be formatted into a string.
  appendTo | Output parameter to receive result. Result is appended to existing contents.

Returns
  Reference to 'appendTo' parameter.

Stable
  ICU 2.0

References U_I18N_API.

## format() [7/8]

U_I18N_API UnicodeString & icu::DateFormat::format | ( | UDate | date,
|  | UnicodeString & | appendTo,
|  | FieldPosition & | fieldPosition ) const

Formats a UDate into a date/time string.

On input, the FieldPosition parameter may have its "field" member filled with an enum value specifying a field. On output, the FieldPosition will be filled in with the text offsets for that field.

For example, given a time text "1996.07.10 AD at 15:08:56 PDT", if the given fieldPosition.field is UDAT_YEAR_FIELD, the offsets fieldPosition.beginIndex and statfieldPositionus.getEndIndex will be set to 0 and 4, respectively.

Notice that if the same time field appears more than once in a pattern, the status will be set for the first occurrence of that time field. For instance, formatting a UDate to the time string "1 PM PDT (Pacific Daylight Time)" using the pattern "h a z (zzzz)" and the alignment field DateFormat::TIMEZONE_FIELD, the offsets fieldPosition.beginIndex and fieldPosition.getEndIndex will be set to 5 and 8, respectively, for the first occurrence of the timezone pattern character 'z'.

Parameters

  date | UDate to be formatted into a date/time string.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  fieldPosition | On input: an alignment field, if desired (see examples above) On output: the offsets of the alignment field (see examples above)

Returns
  Reference to 'appendTo' parameter.

Stable
  ICU 2.0

References U_I18N_API.

## format() [8/8]

U_I18N_API UnicodeString & icu::DateFormat::format | ( | UDate | date,
|  | UnicodeString & | appendTo,
|  | FieldPositionIterator * | posIter,
|  | UErrorCode & | status ) const

Formats a UDate into a date/time string.

Parameters

  date | UDate to be formatted into a date/time string.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  posIter | On return, can be used to iterate over positions of fields generated by this format call. Field values are defined in UDateFormatField. Can be nullptr.
  status | error status.

Returns
  Reference to 'appendTo' parameter.

Stable
  ICU 4.4

References U_I18N_API.

## getAvailableLocales()

U_I18N_API const Locale * icu::DateFormat::getAvailableLocales | ( | int32_t & | count | ) |

static

Gets the set of locales for which DateFormats are installed.

Parameters

  count | Filled in with the number of locales in the list that is returned.

Returns
  the set of locales for which DateFormats are installed. The caller does NOT own this list and must not delete it.

Stable
  ICU 2.0

References U_I18N_API.

## getBestPattern()

U_I18N_API UnicodeString icu::DateFormat::getBestPattern | ( | const Locale & | locale,
|  | const UnicodeString & | skeleton,
|  | UErrorCode & | status )

static

Returns the best pattern given a skeleton and locale.

Parameters

  locale | the locale
  skeleton | the skeleton
  status | ICU error returned here

Returns
  the best pattern.

Internal
  Do not use. This API is for internal use only. For ICU use only.

References U_I18N_API.

## getBooleanAttribute()

virtual U_I18N_API UBool icu::DateFormat::getBooleanAttribute | ( | UDateFormatBooleanAttribute | attr,
|  | UErrorCode & | status ) const

virtual

Returns a boolean from this DateFormat May return U_UNSUPPORTED_ERROR if this instance does not support the specified attribute.

Parameters

  attr | the attribute to set
  status | the error type

Returns
  the attribute value. Undefined if there is an error.

Stable
  ICU 53

References U_I18N_API.

## getCalendar()

virtual U_I18N_API const Calendar * icu::DateFormat::getCalendar | ( |  | ) | const

virtual

Gets the calendar associated with this date/time formatter.

The calendar is owned by the formatter and must not be modified. Also, the calendar does not reflect the results of a parse operation. To parse to a calendar, use `parse(const UnicodeString&, Calendar& cal, ParsePosition&)`

Returns
  the calendar associated with this date/time formatter.

Stable
  ICU 2.0

References U_I18N_API.

## getContext()

virtual U_I18N_API UDisplayContext icu::DateFormat::getContext | ( | UDisplayContextType | type,
|  | UErrorCode & | status ) const

virtual

Get the formatter's UDisplayContext value for the specified UDisplayContextType, such as UDISPCTX_TYPE_CAPITALIZATION.

Parameters

  type | The UDisplayContextType whose value to return
  status | Input/output status. If at entry this indicates a failure status, the function will do nothing; otherwise this will be updated with any new status from the function.

Returns
  The UDisplayContextValue for the specified type.

Stable
  ICU 53

References U_I18N_API.

## getNumberFormat()

virtual U_I18N_API const NumberFormat * icu::DateFormat::getNumberFormat | ( |  | ) | const

virtual

Gets the number formatter which this date/time formatter uses to format and parse the numeric portions of the pattern.

Returns
  the number formatter which this date/time formatter uses.

Stable
  ICU 2.0

References U_I18N_API.

## getTimeZone()

virtual U_I18N_API const TimeZone & icu::DateFormat::getTimeZone | ( |  | ) | const

virtual

Returns a reference to the TimeZone used by this DateFormat's calendar.

Returns
  the time zone associated with the calendar of DateFormat.

Stable
  ICU 2.0

References U_I18N_API.

## isCalendarLenient()

virtual U_I18N_API UBool icu::DateFormat::isCalendarLenient | ( |  | ) | const

virtual

Returns whether date/time parsing in the encapsulated Calendar object processing is lenient.

Stable
  ICU 53

References U_I18N_API.

## isLenient()

virtual U_I18N_API UBool icu::DateFormat::isLenient | ( |  | ) | const

virtual

Returns whether both date/time parsing in the encapsulated Calendar object and DateFormat whitespace & numeric processing is lenient.

Stable
  ICU 2.0

References U_I18N_API.

## operator=()

U_I18N_API DateFormat & icu::DateFormat::operator= | ( | const DateFormat & |  | ) |

protected

Default assignment operator.

Stable
  ICU 2.0

References DateFormat(), and U_I18N_API.

## operator==()

virtual U_I18N_API bool icu::DateFormat::operator== | ( | const Format & |  | ) | const

override virtual

Equality operator.

Returns true if the two formats have the same behavior.

Stable
  ICU 2.0

Implements icu::Format.

Reimplemented in icu::SimpleDateFormat.

References icu::Format::Format(), icu::Format::format(), and U_I18N_API.

## parse() [1/3]

virtual U_I18N_API void icu::DateFormat::parse | ( | const UnicodeString & | text,
|  | Calendar & | cal,
|  | ParsePosition & | pos ) const

pure virtual

Parse a date/time string beginning at the given parse position.

For example, a time text "07/10/96 4:5 PM, PDT" will be parsed into a Date that is equivalent to Date(837039928046).

By default, parsing is lenient: If the input is not in the form used by this object's format method but can still be parsed as a date, then the parse succeeds. Clients may insist on strict adherence to the format by calling setLenient(false).

See also
  DateFormat::setLenient(boolean)

Parameters

  text | The date/time string to be parsed.

  cal

  A Calendar set on input to the date and time to be used for missing values in the date/time string being parsed, and set on output to the parsed date/time. When the calendar type is different from the internal calendar held by this DateFormat instance, the internal calendar will be cloned to a work calendar set to the same milliseconds and time zone as the cal parameter, field values will be parsed based on the work calendar, then the result (milliseconds and time zone) will be set in this calendar.

  pos | On input, the position at which to start parsing; on output, the position at which parsing terminated, or the start position if the parse failed.

Stable
  ICU 2.1

Implemented in icu::SimpleDateFormat.

References U_I18N_API.

## parse() [2/3]

U_I18N_API UDate icu::DateFormat::parse | ( | const UnicodeString & | text,
|  | ParsePosition & | pos ) const

Parse a date/time string beginning at the given parse position.

For example, a time text "07/10/96 4:5 PM, PDT" will be parsed into a Date that is equivalent to Date(837039928046).

By default, parsing is lenient: If the input is not in the form used by this object's format method but can still be parsed as a date, then the parse succeeds. Clients may insist on strict adherence to the format by calling setLenient(false).

See also
  DateFormat::setLenient(boolean)

Note that the normal date formats associated with some calendars - such as the Chinese lunar calendar - do not specify enough fields to enable dates to be parsed unambiguously. In the case of the Chinese lunar calendar, while the year within the current 60-year cycle is specified, the number of such cycles since the start date of the calendar (in the ERA field of the Calendar object) is not normally part of the format, and parsing may assume the wrong era. For cases such as this it is recommended that clients parse using the method parse(const UnicodeString&, Calendar& cal, ParsePosition&) with the Calendar passed in set to the current date, or to a date within the era/cycle that should be assumed if absent in the format.

Parameters

  text | The date/time string to be parsed into a UDate value.
  pos | On input, the position at which to start parsing; on output, the position at which parsing terminated, or the start position if the parse failed.

Returns
  A valid UDate if the input could be parsed.

Stable
  ICU 2.0

References U_I18N_API.

## parse() [3/3]

virtual U_I18N_API UDate icu::DateFormat::parse | ( | const UnicodeString & | text,
|  | UErrorCode & | status ) const

virtual

Parse a date/time string.

For example, a time text "07/10/96 4:5 PM, PDT" will be parsed into a UDate that is equivalent to Date(837039928046). Parsing begins at the beginning of the string and proceeds as far as possible. Assuming no parse errors were encountered, this function doesn't return any information about how much of the string was consumed by the parsing. If you need that information, use the version of parse() that takes a ParsePosition.

By default, parsing is lenient: If the input is not in the form used by this object's format method but can still be parsed as a date, then the parse succeeds. Clients may insist on strict adherence to the format by calling setLenient(false).

See also
  DateFormat::setLenient(boolean)

Note that the normal date formats associated with some calendars - such as the Chinese lunar calendar - do not specify enough fields to enable dates to be parsed unambiguously. In the case of the Chinese lunar calendar, while the year within the current 60-year cycle is specified, the number of such cycles since the start date of the calendar (in the ERA field of the Calendar object) is not normally part of the format, and parsing may assume the wrong era. For cases such as this it is recommended that clients parse using the method parse(const UnicodeString&, Calendar& cal, ParsePosition&) with the Calendar passed in set to the current date, or to a date within the era/cycle that should be assumed if absent in the format.

Parameters

  text | The date/time string to be parsed into a UDate value.
  status | Output param to be set to success/failure code. If 'text' cannot be parsed, it will be set to a failure code.

Returns
  The parsed UDate value, if successful.

Stable
  ICU 2.0

Reimplemented in icu::SimpleDateFormat.

References U_I18N_API.

Referenced by icu::SimpleDateFormat::format().

## parseObject()

virtual U_I18N_API void icu::DateFormat::parseObject | ( | const UnicodeString & | source,
|  | Formattable & | result,
|  | ParsePosition & | parse_pos ) const

override virtual

Parse a string to produce an object.

This methods handles parsing of date/time strings into Formattable objects with UDate types.

Before calling, set parse_pos.index to the offset you want to start parsing at in the source. After calling, parse_pos.index is the end of the text you parsed. If error occurs, index is unchanged.

When parsing, leading whitespace is discarded (with a successful parse), while trailing whitespace is left as is.

See Format::parseObject() for more.

Parameters

  source | The string to be parsed into an object.
  result | Formattable to be set to the parse result. If parse fails, return contents are undefined.
  parse_pos | The position to start parsing at. Upon return this param is set to the position after the last character successfully parsed. If the source is not parsed successfully, this param will remain unchanged.

Stable
  ICU 2.0

Implements icu::Format.

References U_I18N_API.

## setBooleanAttribute()

virtual U_I18N_API DateFormat & icu::DateFormat::setBooleanAttribute | ( | UDateFormatBooleanAttribute | attr,
|  | UBool | newvalue,
|  | UErrorCode & | status )

virtual

Sets an boolean attribute on this DateFormat.

May return U_UNSUPPORTED_ERROR if this instance does not support the specified attribute.

Parameters

  attr | the attribute to set
  newvalue | new value
  status | the error type

Returns
  *this - for chaining (example: format.setAttribute(...).setAttribute(...) )

Stable
  ICU 53

References DateFormat(), and U_I18N_API.

## setCalendar()

virtual U_I18N_API void icu::DateFormat::setCalendar | ( | const Calendar & | newCalendar | ) |

virtual

Set the calendar to be used by this date format.

Initially, the default calendar for the specified or default locale is used.

Parameters

  newCalendar | Calendar object to be set.

Stable
  ICU 2.0

References U_I18N_API.

## setCalendarLenient()

virtual U_I18N_API void icu::DateFormat::setCalendarLenient | ( | UBool | lenient | ) |

virtual

Specifies whether encapsulated Calendar date/time parsing is to be lenient.

With lenient parsing, the parser may use heuristics to interpret inputs that do not precisely match this object's format. Without lenient parsing, inputs must match this object's format more closely.

Parameters

  lenient | when true, parsing is lenient

See also
  com.ibm.icu.util.Calendar#setLenient

Stable
  ICU 53

References U_I18N_API.

## setContext()

virtual U_I18N_API void icu::DateFormat::setContext | ( | UDisplayContext | value,
|  | UErrorCode & | status )

virtual

Set a particular UDisplayContext value in the formatter, such as UDISPCTX_CAPITALIZATION_FOR_STANDALONE.

Parameters

  value | The UDisplayContext value to set.
  status | Input/output status. If at entry this indicates a failure status, the function will do nothing; otherwise this will be updated with any new status from the function.

Stable
  ICU 53

Reimplemented in icu::SimpleDateFormat.

References U_I18N_API.

## setLenient()

virtual U_I18N_API void icu::DateFormat::setLenient | ( | UBool | lenient | ) |

virtual

Specifies whether date/time parsing is to be lenient.

With lenient parsing, the parser may use heuristics to interpret inputs that do not precisely match this object's format. Without lenient parsing, inputs must match this object's format more closely.

Note: ICU 53 introduced finer grained control of leniency (and added new control points) making the preferred method a combination of setCalendarLenient() & setBooleanAttribute() calls. This method supports prior functionality but may not support all future leniency control & behavior of DateFormat. For control of pre 53 leniency,
Calendar and DateFormat whitespace & numeric tolerance, this method is safe to use. However, mixing leniency control via this method and modification of the newer attributes via setBooleanAttribute() may produce undesirable results.

Parameters

  lenient | True specifies date/time interpretation to be lenient.

See also
  Calendar::setLenient

Stable
  ICU 2.0

References U_I18N_API.

## setNumberFormat()

virtual U_I18N_API void icu::DateFormat::setNumberFormat | ( | const NumberFormat & | newNumberFormat | ) |

virtual

Allows you to set the number formatter.

Parameters

  newNumberFormat | NumberFormat object to be set.

Stable
  ICU 2.0

References U_I18N_API.

## setTimeZone()

virtual U_I18N_API void icu::DateFormat::setTimeZone | ( | const TimeZone & | zone | ) |

virtual

Sets the time zone for the calendar of this DateFormat object.

Parameters

  zone | the new time zone.

Stable
  ICU 2.0

References U_I18N_API.

## Friends And Related Symbol Documentation

## DateFmtKeyByStyle

friend class DateFmtKeyByStyle

friend

Definition at line 882 of file datefmt.h.

## Field Documentation

## fCalendar

Calendar* icu::DateFormat::fCalendar

protected

The calendar that DateFormat uses to produce the time field values needed to implement date/time formatting.

Subclasses should generally initialize this to the default calendar for the locale associated with this DateFormat.

Stable
  ICU 2.4

Definition at line 851 of file datefmt.h.

## fNumberFormat

NumberFormat* icu::DateFormat::fNumberFormat

protected

The number formatter that DateFormat uses to format numbers in dates and times.

Subclasses should generally initialize this to the default number format for the locale associated with this DateFormat.

Stable
  ICU 2.4

Definition at line 859 of file datefmt.h.

The documentation for this class was generated from the following file:

- i18n/unicode/datefmt.h